from typing import Any, Callable, List, Optional, Tuple, Union

from com.inductiveautomation.factorypmi.application import FPMIWindow
from com.inductiveautomation.factorypmi.application.script.builtin import (
    WindowUtilities,
)
from java.awt import Color
from java.lang import String
from java.org.jdesktop.core.animation.timing import Animator
from java.util import EventObject
from javax.swing import JComponent, JFrame, JPopupMenu

Number = Union[float, int]
ACCL_NONE: int
ACCL_CONSTANT: int
ACCL_FAST_TO_SLOW: int
ACCL_SLOW_TO_FAST: int
ACCL_EASE: int
COORD_DESIGNER: int
COORD_SCREEN: int

def chooseColor(initialColor: Color, dialogTitle: String = ...) -> Color: ...
def closeDesktop(handle: String) -> None: ...
def color(*args: Any) -> Color: ...
def confirm(
    message: String, title: String = ..., allowCancel: bool = ...
) -> Optional[bool]: ...
def convertPointToScreen(x: int, y: int, event: EventObject) -> Tuple[int, int]: ...
def createPopupMenu(
    itemNames: List[String], itemFunctions: List[Callable[..., Any]]
) -> JPopupMenu: ...
def desktop(handle: String) -> WindowUtilities: ...
def errorBox(message: String, title: String = ...) -> None: ...
def findWindow(path: String) -> List[FPMIWindow]: ...
def getCurrentDesktop() -> String: ...
def getDesktopHandles() -> List[String]: ...
def getOpenedWindowNames() -> Tuple[String, ...]: ...
def getOpenedWindows() -> Tuple[FPMIWindow, ...]: ...
def getParentWindow(event: EventObject) -> FPMIWindow: ...
def getQuality(component: JComponent, propertyName: String) -> int: ...
def getScreenIndex() -> int: ...
def getScreens() -> List[Tuple[String, int, int]]: ...
def getSibling(event: EventObject, name: String) -> FPMIWindow: ...
def getWindow(name: String) -> FPMIWindow: ...
def getWindowNames() -> Tuple[String, ...]: ...
def inputBox(message: String, defaultText: String = ...) -> Optional[String]: ...
def isTouchscreenModeEnabled() -> bool: ...
def messageBox(message: String, title: String = ...) -> None: ...
def openDesktop(
    screen: int = ...,
    handle: Optional[String] = ...,
    title: Optional[String] = ...,
    width: Optional[int] = ...,
    height: Optional[int] = ...,
    x: int = ...,
    y: int = ...,
    windows: Optional[List[String]] = ...,
) -> JFrame: ...
def openDiagnostics() -> None: ...
def passwordBox(
    message: String, title: String = ..., echoChar: String = ...
) -> Optional[String]: ...
def setScreenIndex(index: int) -> None: ...
def setTouchscreenModeEnabled(enabled: bool) -> None: ...
def showNumericKeypad(
    initialValue: Number, fontSize: Optional[int] = ..., usePasswordMode: bool = ...
) -> Number: ...
def showTouchscreenKeyboard(
    initialText: String,
    fontSize: Optional[int] = ...,
    passwordMode: Optional[bool] = ...,
) -> String: ...
def transform(
    component: JComponent,
    newX: Optional[int] = ...,
    newY: Optional[int] = ...,
    newWidth: Optional[int] = ...,
    newHeight: Optional[int] = ...,
    duration: int = ...,
    callback: Optional[Callable[..., Any]] = ...,
    framesPerSecond: int = ...,
    acceleration: Optional[int] = ...,
    coordSpace: Optional[int] = ...,
) -> Animator: ...
def warningBox(message: String, title: String = ...) -> None: ...
